
#include "llvm/Pass.h"
#include "llvm/IR/IRBuilder.h"
#include "llvm/IR/Module.h"
#include "llvm/IR/Function.h"
#include "llvm/Support/raw_ostream.h"
#include "llvm/IR/InstrTypes.h"
#include "llvm/Transforms/Utils/BasicBlockUtils.h"


using namespace llvm;

// anonymous namespace -> avoid exporting unneeded symbols
namespace {
  struct MemWrites : public FunctionPass {
    static char ID;

    MemWrites() : FunctionPass(ID) { }

    //called on each function of the module
    virtual bool runOnFunction(Function &F) {
      errs() << "Function " << F.getName() << "\n";
      
      return false;
    }
  };
}

// pass registration is done through the constructor of static objects...

/* opt pass registration
 */
char MemWrites::ID = 0;
static RegisterPass<MemWrites>
    X("mwrites",  // the option name -> -mwrites
      "Count Memory Writes", // option description
      true, // true as we don't modify the CFG
      true // true if we're writing an analysis
      );

/* clang pass registration (optional)
 */
#include "llvm/IR/LegacyPassManager.h"
#include "llvm/Transforms/IPO/PassManagerBuilder.h"

static void registerClangPass(const PassManagerBuilder &,
                              legacy::PassManagerBase &PM)
{ PM.add(new MemWrites()); }

// Note the registration point, clang offers several insertion points where you
// can insert your pass.
static RegisterStandardPasses RegisterClangPass
    (PassManagerBuilder::EP_EarlyAsPossible, registerClangPass);

